CREATE OR REPLACE FUNCTION CALCULA_FECP(
   P_IDTPOPERACAO IN VARCHAR2, /*I - Operao Interna, E - Operaes Externas (Interestaduais) */
   P_NRLANCTONF   IN GNRENF.NRLANCTONF%TYPE,
   P_CDFILIAL     IN GNRENF.CDFILIAL%TYPE,
   P_NRSEQUMAPAPU IN GNREMAPA.NRSEQUMAPAPU%TYPE,
   P_CDEMPRESA    IN PARAMGNRE.CDEMPRESA%TYPE) RETURN NUMBER
AS
   V_VRFECP         GNRENF.VRFECPNFGNRE%TYPE;
   V_VRALIQFECP     PARAMGNRE.VRALIQFECP%TYPE;
   V_VRBASECALCFECP GNRENF.VRFECPNFGNRE%TYPE;
BEGIN
   V_VRFECP         := 0;
   V_VRALIQFECP     := 0;
   V_VRBASECALCFECP := 0;

   BEGIN
      SELECT VRALIQFECP
        INTO V_VRALIQFECP
        FROM PARAMGNRE
       WHERE CDEMPRESA = P_CDEMPRESA;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_VRALIQFECP := 0;
   END;

   /*No clculo do FECP, para Operaes Internas a base de clculo  a diferena entre a base de clculo do ICMS Retido
     e a base de clculo do ICMS, nas Operaes Interestaduais, a base de clculo  a base de clculo do ICMS Retido.*/

   IF V_VRALIQFECP <> 0 THEN
      IF (P_NRSEQUMAPAPU IS NULL) OR (P_NRSEQUMAPAPU = '') THEN  /*FECP por Operao*/
         BEGIN
            SELECT ABS(VALOR_IMPOSTO_NFE(P_CDFILIAL, P_NRLANCTONF, '80', 'B','1') -
                       DECODE(P_IDTPOPERACAO, 'I', VALOR_IMPOSTO_NFE(P_CDFILIAL, P_NRLANCTONF, '00', 'B','1'), 0)) AS BASECALC
              INTO V_VRBASECALCFECP
              FROM DUAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRBASECALCFECP := 0;
         END;
      ELSE /*FECP por Apurao*/
         BEGIN
            SELECT SUM(BASE_ST - BASE_ICMS) AS BASECALC
              INTO V_VRBASECALCFECP
              FROM (SELECT SUM(IP.VRBASECALCNF) AS BASE_ST, IP.NRLANCTONF, IP.CDFILIAL,
                   DECODE(P_IDTPOPERACAO, 'I', VALOR_IMPOSTO_NFE(IP.CDFILIAL, IP.NRLANCTONF, '00', 'B','1'), 0) AS BASE_ICMS
              FROM IMPOSTONF IP, NOTAFISCAL NF, ENDECLIE EC
             WHERE IP.NRSEQUMAPAPUST = P_NRSEQUMAPAPU
               AND IP.CDFISCALNF     = '1'
               AND IP.CDFILIAL       = NF.CDFILIAL
               AND IP.NRLANCTONF     = NF.NRLANCTONF
               AND NF.IDENTRSAIDOP   = 'S'
               AND NF.CDCLIENTE      = EC.CDCLIENTE
               AND EC.SGESTADO       = 'RJ'
               AND EC.IDTPENDECLIE   = 'P'
             GROUP BY IP.NRLANCTONF, IP.CDFILIAL);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRBASECALCFECP := 0;
         END;
      END IF;
      V_VRFECP := ROUND((V_VRBASECALCFECP * V_VRALIQFECP / 100),2);
   END IF;
   RETURN(V_VRFECP);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CALCULA_FECP','5.67.000'); END;
/

