/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_DIASENTR                                                 */
/* Tabela : DIASENTR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_DIASENTR' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_DIASENTR
GO

CREATE TRIGGER DTULTATU_DIASENTR
ON DIASENTR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'DIASENTR', null, 'CDPERIENTR='+ CDPERIENTR+ ';'+
                                       'DIENTREGA=' + DIENTREGA+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE DIASENTR
      SET DTULTATUDIEN = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(DIASENTR.CDPERIENTR,0) = ISNULL(INSERTED.CDPERIENTR,0));
   END;
END;
GO

